<div class="page-layout carded fullwidth" fusePerfectScrollbar>

  <!-- TOP BACKGROUND -->
  <div class="top-bg {{secondColorBrand}}">
    <!-- <div class="h2" class="panel-content" style="background-color:tomato; height: 35px; width: 100%; padding-top: 10px;padding-left: 10px;padding-right: 10px;">
          <span style="color:white;  padding-top: 2px">Alguns serviços estão temporariamente indisponíveis. Isso pode afetar sua experiência no sistema. Nosso time já está trabalhando no problema</span>
      </div>  -->
  </div>
  <!-- / TOP BACKGROUND -->

  <!-- CENTER -->
  <div class="center">

    <!-- HEADER -->
    <div class="header white-fg" fxLayout="row" fxLayoutAlign="space-between center">

      <!-- APP TITLE -->
      <div fxLayout="row" fxLayoutAlign="start center">

        <button class="mr-16" mat-icon-button (click)="routerGoTo()">
          <mat-icon>arrow_back</mat-icon>
        </button>

        <div fxLayout="column" fxLayoutAlign="start start" *fuseIfOnDom [@animate]="{value:'*',params:{delay:'100ms',x:'-25px'}}">
          <div *ngIf="device" class="h2">
            Rastreador - {{device.id}}
          </div>
          <div class="subtitle secondary-text" *ngIf="device && device.status">
            <span>{{ deviceActivityToString(device.status)}}</span>
          </div>
        </div>

      </div>

      <div class="search-input-wrapper mx-6 m-md-0" fxFlex="1 0 auto" fxLayout="row" fxLayoutAlign="end center">
        <form [formGroup]="searchForm" novalidate fxFlex="100" fxLayoutAlign="end center" fxLayoutGap="10px">

          <mat-form-field fxFlex="100">
            <mat-select placeholder="O Rastreador Pertence a Marca" formControlName="brand" (selectionChange)="onBrandValueChanged()">
              <mat-option *ngFor="let brand of brandList" [value]="brand['id']">
                {{ brand['name'] }}
              </mat-option>
            </mat-select>
          </mat-form-field>

        </form>
      </div>

      <!-- / APP TITLE -->

      <div fxLayout="column" fxLayoutAlign="end center">

        <button mat-raised-button [matMenuTriggerFor]="card20Menu" [ngClass]="primaryColorBrand">
          Mudar Status do Rastreador&nbsp;&nbsp;
          <mat-icon>arrow_drop_down</mat-icon>
        </button>

        <mat-menu #card20Menu="matMenu">
          <button fxLayout="row" *ngIf="device && (device.status == 'INACTIVE')" fxLayoutAlign="start center"
            mat-menu-item (click)="activeDevice()">
            <span>Ativar</span>
          </button>
          <button fxLayout="row" *ngIf="device && (device.status == 'CANCELED')" fxLayoutAlign="start center"
            mat-menu-item (click)="reactivateDevice()">
            <span>Reativar</span>
          </button>
          <button fxLayout="row" *ngIf="device && (device.status == 'ACTIVE')" fxLayoutAlign="start center"
            mat-menu-item (click)="cancelDevice()">
            <span>Cancelar</span>
          </button>
          <button fxLayout="row" *ngIf="device && (device.status == 'CANCELED')" fxLayoutAlign="start center"
            mat-menu-item (click)="unistalDevice()">
            <span>Desistalar</span>
          </button>
          <button fxLayout="row" fxLayoutAlign="start center" mat-menu-item (click)="maintenanceDevice()">
            <span>Manutenção</span>
          </button>
          <button fxLayout="row" fxLayoutAlign="start center" mat-menu-item [hidden]="device && (device.status != 'UNINSTALLED')"
            (click)="returnedDevice()">
            <span>Retornar</span>
          </button>
          <button fxLayout="row" fxLayoutAlign="start center" mat-menu-item (click)="discardDevice()">
            <span>Descartar</span>
          </button>

        </mat-menu>

      </div>


    </div>
    <!-- / HEADER -->


    <mat-card>
      
      <mat-card-content>

        <mat-tab-group>
          <mat-tab [ngClass]="primaryColorBrand">
            <ng-template mat-tab-label>
              <mat-icon>gps_fixed</mat-icon>
              <span>&nbsp;Rastreador</span>
            </ng-template>

            <div class="panel" *ngIf="device" [hidden]="isEdit">

              <div class="fuse-widget-front mat-white-bg mat-elevation-z2">

                <div class="px-16 border-bottom" fxLayout="row wrap" fxLayoutAlign="space-between center" [ngClass]="primaryColorBrand">
                  <mat-icon class="white-fg">gps_fixed</mat-icon>
                  <div fxFlex class="py-16 h3">&nbsp;Rastreador</div>

                  <div fxFlex="0 1 auto" class="py-16" fxLayout="row" *ngIf="device && (device.status != 'RETURNED')">
                    <button mat-button class="px-16" [matMenuTriggerFor]="deviceMenu">
                      Ações&nbsp;&nbsp;
                      <mat-icon>arrow_drop_down</mat-icon>
                    </button>

                    <mat-menu #deviceMenu="matMenu">
                      <button fxLayout="row" fxLayoutAlign="start center" mat-menu-item (click)="showEditDevice()">
                        <span>
                          <mat-icon>gps_fixed</mat-icon>
                        </span>
                        <span>Editar Rastreador</span>
                      </button>
                      <button fxLayout="row" fxLayoutAlign="start center" mat-menu-item (click)="showVeicle()" >
                        <span><mat-icon>directions_car</mat-icon></span>
                        <span>{{!vehicleForm.value.manufacturer ? 'Vincular Veículo' : 'Editar Veículo'}}</span>
                      </button>
                      <button fxLayout="row" fxLayoutAlign="start center" mat-menu-item (click)="showCustomer()"  >
                        <span>
                          <mat-icon >assignment_ind</mat-icon>
                        </span>
                        <span>{{ !generalForm.value.name ? 'Vincular Cliente' : 'Editar Cliente'}}</span>
                      </button>
                      <button fxLayout="row" fxLayoutAlign="start center" mat-menu-item (click)="changeCustomer()" *ngIf="generalForm.value.name && device && device.status != 'INACTIVE' ">
                        <span><mat-icon>assignment_ind</mat-icon></span>
                        <span>Trocar Cliente</span>
                      </button>
                    </mat-menu>
                  </div>
                </div>
              </div>

              <div class="panel-content">
                <form [formGroup]="deviceForm">
                  <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px">

                    <mat-form-field fxFlex="33">
                      <input matInput placeholder="Modelo" formControlName="model" required style="color: black">
                    </mat-form-field>

                    <mat-form-field fxFlex="33">
                      <input matInput placeholder="Status" formControlName="status" required style="color: black">
                    </mat-form-field>

                    <mat-form-field fxFlex="33">
                      <mat-select placeholder="Marca" formControlName="brand" required style="color: black">
                        <mat-option *ngFor="let brand of brandList" [value]="brand['id']">
                          {{ brand['name'] }}
                        </mat-option>
                      </mat-select>
                    </mat-form-field>
                  </div>

                  <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px">

                    <mat-form-field fxFlex="33">
                      <input matInput placeholder="Operadora" formControlName="operator" required style="color: black">
                    </mat-form-field>

                    <mat-form-field fxFlex="34">
                      <input matInput placeholder="Número" formControlName="number" required style="color: black">
                    </mat-form-field>

                    <mat-form-field fxFlex="33">
                      <input matInput placeholder="Sim-Card" formControlName="simCard" required style="color: black">
                    </mat-form-field>
                  </div>

                  <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px">

                    <mat-form-field fxFlex="33">
                      <input matInput placeholder="Id" formControlName="id" required style="color: black">
                    </mat-form-field>

                    <mat-form-field fxFlex="33">
                      <input matInput placeholder="Identificador" formControlName="identifier" required style="color: black">
                    </mat-form-field>

                    <mat-form-field fxFlex="34">
                      <input matInput placeholder="imei" formControlName="imei" required style="color: black">
                    </mat-form-field>
                  </div>
                  <div class="checkBoxPadding" fxLayout="row" fxLayoutAlign="start left" fxLayoutGap="10px">
                    <mat-checkbox formControlName="hidden" (change)="updateDeviceHiddenCheckBox(device.hidden)">Ocultar para usuário final</mat-checkbox>
                   </div>  

                  <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px" *ngIf="device && device['lifecycle'] && device['lifecycle'].inactiveDate ">

                    <mat-form-field fxFlex="47">
                            <input matInput placeholder="Criado em"  formControlName="inactiveDate" style="color: black" required >
                    </mat-form-field>
                    <div fxFlex="3" [hidden]="!isTracknme"> 
                        <input [matDatepicker]="picker" style="color: transparent; width: 2px;"  disabled="true" (dateChange)="dateOnChange($event,'inactiveDate')">
                        <mat-datepicker-toggle matSuffix [for]="picker"></mat-datepicker-toggle>
                        <mat-datepicker #picker disabled="false" ></mat-datepicker>
                    </div>
                   
                    <mat-form-field fxFlex="47">
                          <input matInput placeholder="Criado por" formControlName="userLoggedInactive" style="color: black" required>
                    </mat-form-field>
                    <div fxFlex="3" [hidden]="!isTracknme"> 
                        <mat-icon  style="cursor:pointer" class="logo-icon mr-16" (click)='searchOnChange("userLoggedInactive")' >edit</mat-icon>
                    </div>
                  
                  </div>

                  <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px" *ngIf="device && device['lifecycle'] && device['lifecycle'].activeDate ">

                    <mat-form-field fxFlex="47">
                            <input matInput placeholder="Ativado em" formControlName="activeDate" style="color: black" required>
                    </mat-form-field>
                    <div fxFlex="3" [hidden]="!isTracknme">  
                        <input [matDatepicker]="pickerActiveDate" style="color: transparent; width: 2px;"  disabled="true" (dateChange)="dateOnChange($event,'activeDate')">
                        <mat-datepicker-toggle matSuffix [for]="pickerActiveDate"></mat-datepicker-toggle>
                        <mat-datepicker #pickerActiveDate disabled="false" ></mat-datepicker>
                    </div>

                    <mat-form-field fxFlex="47">
                        <input matInput placeholder="Ativado por" formControlName="userLoggedActive" style="color: black" required>
                    </mat-form-field>
                    <div fxFlex="3" [hidden]="!isTracknme">  
                        <mat-icon  style="cursor:pointer" class="logo-icon mr-16" (click)='searchOnChange("userLoggedActive")' >edit</mat-icon>
                    </div>

                  </div>

                  <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px" *ngIf="device && device['lifecycle'] && device['lifecycle'].reactivateDate ">

                    <mat-form-field fxFlex="47">
                        <input matInput placeholder="Reativado em" formControlName="reactivateDate" style="color: black" required>
                    </mat-form-field>
                    <div fxFlex="3" [hidden]="!isTracknme">  
                        <input [matDatepicker]="pickerReactivateDate" style="color: transparent; width: 2px;"  disabled="true" (dateChange)="dateOnChange($event,'reactivateDate')">
                        <mat-datepicker-toggle matSuffix [for]="pickerReactivateDate"></mat-datepicker-toggle>
                        <mat-datepicker #pickerReactivateDate disabled="false" ></mat-datepicker>
                    </div>

                    <mat-form-field fxFlex="47">
                          <input matInput placeholder="Reativado por" formControlName="userLoggedReactivate" style="color: black" required>
                    </mat-form-field>
                    <div fxFlex="3" [hidden]="!isTracknme">  
                        <mat-icon  style="cursor:pointer" class="logo-icon mr-16" (click)='searchOnChange("userLoggedReactivate")' >edit</mat-icon>
                    </div>

                  </div>

                  <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px" *ngIf="device && device['lifecycle'] && device['lifecycle'].canceledDate ">

                    <mat-form-field fxFlex="47">
                          <input matInput placeholder="Cancelado em" formControlName="canceledDate" style="color: black" required>
                    </mat-form-field>
                    <div fxFlex="3" [hidden]="!isTracknme">  
                        <input [matDatepicker]="pickerCanceledDate" style="color: transparent; width: 2px;"  disabled="true" (dateChange)="dateOnChange($event,'canceledDate')">
                        <mat-datepicker-toggle matSuffix [for]="pickerCanceledDate"></mat-datepicker-toggle>
                        <mat-datepicker #pickerCanceledDate disabled="false" ></mat-datepicker>
                    </div>

                    <mat-form-field fxFlex="50">
                          <input matInput placeholder="Cancelado por" formControlName="userLoggedCanceled" style="color: black" required>
                    </mat-form-field>
                    <div fxFlex="3" [hidden]="!isTracknme">  
                        <mat-icon  style="cursor:pointer" class="logo-icon mr-16" (click)='searchOnChange("userLoggedCanceled")' >edit</mat-icon>
                    </div>

                  </div>

                  <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px" *ngIf="device && device['lifecycle'] && device['lifecycle'].receivedDate ">

                    <mat-form-field fxFlex="47">
                          <input matInput placeholder="Recuperado em" formControlName="receivedDate" style="color: black" required>
                    </mat-form-field>
                    <div fxFlex="3" [hidden]="!isTracknme">  
                        <input [matDatepicker]="pickerReceivedDate" style="color: transparent; width: 2px;"  disabled="true" (dateChange)="dateOnChange($event,'receivedDate')">
                        <mat-datepicker-toggle matSuffix [for]="pickerReceivedDate"></mat-datepicker-toggle>
                        <mat-datepicker #pickerReceivedDate disabled="false" ></mat-datepicker>
                    </div>

                    <mat-form-field fxFlex="47">
                          <input matInput placeholder="Recuperado por" formControlName="userLoggedReceived" style="color: black" required>
                    </mat-form-field>
                    <div fxFlex="3" [hidden]="!isTracknme">  
                        <mat-icon  style="cursor:pointer" class="logo-icon mr-16" (click)='searchOnChange("userLoggedReceived")' >edit</mat-icon>
                    </div>

                  </div>

                  <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px" *ngIf="device && device['lifecycle'] && device['lifecycle'].uninstalledDate ">

                    <mat-form-field fxFlex="47">
                          <input matInput placeholder="Desistalado em" formControlName="uninstalledDate" style="color: black" required>
                    </mat-form-field>
                    <div fxFlex="3" [hidden]="!isTracknme">  
                        <input [matDatepicker]="pickerUninstalledDate" style="color: transparent; width: 2px;"  disabled="true" (dateChange)="dateOnChange($event,'uninstalledDate')">
                        <mat-datepicker-toggle matSuffix [for]="pickerUninstalledDate"></mat-datepicker-toggle>
                        <mat-datepicker #pickerUninstalledDate disabled="false" ></mat-datepicker>
                    </div>

                    <mat-form-field fxFlex="47">
                          <input matInput placeholder="Desistalado por" formControlName="userLoggedUninstalled" style="color: black" required>
                    </mat-form-field>
                    <div fxFlex="3" [hidden]="!isTracknme">  
                        <mat-icon  style="cursor:pointer" class="logo-icon mr-16" (click)='searchOnChange("userLoggedUninstalled")' >edit</mat-icon>
                    </div>

                  </div>

                  <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px" *ngIf="device && device['lifecycle'] && device['lifecycle'].discardedDate ">

                    <mat-form-field fxFlex="47">
                          <input matInput placeholder="Descartado em" formControlName="discardedDate" style="color: black" required>
                    </mat-form-field>
                    <div fxFlex="3" [hidden]="!isTracknme">  
                        <input [matDatepicker]="pickerDiscardedDate" style="color: transparent; width: 2px;"  disabled="true" (dateChange)="dateOnChange($event,'discardedDate')">
                        <mat-datepicker-toggle matSuffix [for]="pickerDiscardedDate"></mat-datepicker-toggle>
                        <mat-datepicker #pickerDiscardedDate disabled="false" ></mat-datepicker>
                    </div>

                    <mat-form-field fxFlex="47">
                        <input matInput placeholder="Descartado por" formControlName="userLoggedDiscarded" style="color: black" required>
                    </mat-form-field>
                    <div fxFlex="3" [hidden]="!isTracknme">  
                        <mat-icon  style="cursor:pointer" class="logo-icon mr-16" (click)='searchOnChange("userLoggedDiscarded")' >edit</mat-icon>
                    </div>

                  </div>

                  <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px" *ngIf="device && device['lifecycle'] && device['lifecycle'].testedDate ">

                    <mat-form-field fxFlex="47">
                          <input matInput placeholder="Testado em" formControlName="testedDate" style="color: black" required>
                    </mat-form-field>
                    <div fxFlex="3" [hidden]="!isTracknme">  
                        <input [matDatepicker]="pickerTestedDate" style="color: transparent; width: 2px;"  disabled="true" (dateChange)="dateOnChange($event,'testedDate')">
                        <mat-datepicker-toggle matSuffix [for]="pickerTestedDate"></mat-datepicker-toggle>
                        <mat-datepicker #pickerTestedDate disabled="false" ></mat-datepicker>
                    </div>

                    <mat-form-field fxFlex="47">
                        <input matInput placeholder="Testado por" formControlName="userLoggedTested" style="color: black" required>
                    </mat-form-field>
                    <div fxFlex="3" [hidden]="!isTracknme">  
                        <mat-icon  style="cursor:pointer" class="logo-icon mr-16" (click)='searchOnChange("userLoggedTested")' >edit</mat-icon>
                    </div>

                  </div>

                  <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px" *ngIf="device && device['lifecycle'] && device['lifecycle'].underMaintenanceDate ">

                    <mat-form-field fxFlex="47">
                          <input matInput placeholder="Manutenção em" formControlName="underMaintenanceDate" style="color: black" required>
                    </mat-form-field>
                    <div fxFlex="3" [hidden]="!isTracknme">  
                        <input [matDatepicker]="pickerUnderMaintenanceDate" style="color: transparent; width: 2px;"  disabled="true" (dateChange)="dateOnChange($event,'underMaintenanceDate')">
                        <mat-datepicker-toggle matSuffix [for]="pickerUnderMaintenanceDate"></mat-datepicker-toggle>
                        <mat-datepicker #pickerUnderMaintenanceDate disabled="false" ></mat-datepicker>
                    </div>

                    <mat-form-field fxFlex="47">
                          <input matInput placeholder="Colocado em Manutenção por" formControlName="userLoggedUnderMaintenance" style="color: black" required>
                    </mat-form-field>
                    <div fxFlex="3" [hidden]="!isTracknme">  
                        <mat-icon  style="cursor:pointer" class="logo-icon mr-16" (click)='searchOnChange("userLoggedUnderMaintenance")' >edit</mat-icon>
                    </div>

                  </div>

                  <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px" *ngIf="device && device['lifecycle'] && device['lifecycle'].returnedDate ">

                    <mat-form-field fxFlex="47">
                          <input matInput placeholder="Retornado em" formControlName="returnedDate" style="color: black" required>
                    </mat-form-field>
                    <div fxFlex="3" [hidden]="!isTracknme">  
                        <input [matDatepicker]="pickerReturnedDate" style="color: transparent; width: 2px;"  disabled="true" (dateChange)="dateOnChange($event,'returnedDate')">
                        <mat-datepicker-toggle matSuffix [for]="pickerReturnedDate"></mat-datepicker-toggle>
                        <mat-datepicker #pickerReturnedDate disabled="false" ></mat-datepicker>
                    </div>

                    <mat-form-field fxFlex="47">
                        <div class="logo my-12 m-sm-0" fxLayout="row" fxLayoutAlign="start center">
                          <input matInput placeholder="Retornado por" formControlName="userLoggedReturned" style="color: black" required>
                        </div>
                    </mat-form-field>
                    <div fxFlex="3" [hidden]="!isTracknme">  
                        <mat-icon  style="cursor:pointer" class="logo-icon mr-16" (click)='searchOnChange("userLoggedReturned")' >edit</mat-icon>
                    </div>

                  </div>

                </form>

              </div>

            
            </div>
            <div class="panel" *ngIf="device" [hidden]="!isEdit">

              <div class="fuse-widget-front mat-white-bg mat-elevation-z2">

                <div class="px-16 border-bottom" fxLayout="row wrap" fxLayoutAlign="space-between center" [ngClass]="!isEdit ? primaryColorBrand : editColor">
                  <mat-icon class="white-fg">gps_fixed</mat-icon>
                  <div fxFlex class="py-16 h3">&nbsp;Rastreador</div>

                  <div fxFlex="0 1 auto" class="py-16" fxLayout="row">
                    <button mat-button class="px-16" [matMenuTriggerFor]="deviceMenu">
                      Ações&nbsp;&nbsp;
                      <mat-icon>arrow_drop_down</mat-icon>
                    </button>

                    <mat-menu #deviceMenu="matMenu">
                      <button fxLayout="row" fxLayoutAlign="start center" mat-menu-item (click)="showEditDevice()">
                        <span>
                          <mat-icon>gps_fixed</mat-icon>
                        </span>
                        <span>Editar Rastreador</span>
                      </button>
                      <button fxLayout="row" fxLayoutAlign="start center" mat-menu-item (click)="showVeicle()">
                        <span><mat-icon>directions_car</mat-icon></span>
                        <span>{{!vehicleForm.value.manufacturer ? 'Vincular Veículo' : 'Editar Veículo'}}</span>
                      </button>
                      <button fxLayout="row" fxLayoutAlign="start center" mat-menu-item (click)="showCustomer()">
                        <span>
                          <mat-icon >assignment_ind</mat-icon>
                        </span>
                        <span>{{ !generalForm.value.name ? 'Vincular Cliente' : 'Editar Cliente'}}</span>
                      </button>
                    </mat-menu>
                  </div>

                </div>
              </div>

              <div class="panel-content">

                <form [formGroup]="deviceEditForm" novalidate>
                  <mat-dialog-content>

                    <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px">
                      <mat-form-field fxFlex="50">
                        <input type="number" matInput #input maxlength="15" placeholder="IMEI" formControlName="imei">
                        <mat-hint position="end">{{input.value?.length || 0}}/15</mat-hint>
                        <mat-error *ngIf="deviceEditForm.get('imei').hasError('required')">
                          Por favor, informe o IMEI
                        </mat-error>
                      </mat-form-field>
                      <mat-form-field fxFlex="50">
                        <input type="number" matInput placeholder="Identificador" formControlName="identifier">
                      </mat-form-field>

                    </div>

                    <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px">
                      <mat-form-field fxFlex="100">

                        <mat-select placeholder="Modelo" formControlName="model">
                          <mat-option value="">Selecione um modelo</mat-option>
                          <mat-option *ngFor="let device of deviceModelList" [value]="device.key">
                            {{ device.value }}
                          </mat-option>
                        </mat-select>
                        <mat-error *ngIf="deviceEditForm.get('model').hasError('required')">
                          Por favor, seleciona um modelo
                        </mat-error>

                      </mat-form-field>
                    </div>
                    <div class="checkBoxPadding"  fxLayout="row" fxLayoutAlign="start left" fxLayoutGap="10px">
                      <mat-checkbox formControlName="hidden">Ocultar para usuário final</mat-checkbox>
                     </div>  

                    <b><span class="title">*Configuração Sim Card Opcional</span></b>

                    <br><br>

                    <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px">
                      <mat-form-field fxFlex="50">
                        <input matInput [textMask]="{mask: phoneMask}" placeholder="Número da linha" formControlName="number">

                      </mat-form-field>

                      <mat-form-field fxFlex="50">
                        <input matInput [textMask]="{mask: simCardMask}" placeholder="Número do SimCard"
                          formControlName="simCard">

                      </mat-form-field>
                    </div>



                    <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px">
                      <mat-form-field fxFlex="100">
                        <mat-select placeholder="Operadora" formControlName="operator">
                          <mat-option value="">Selecione uma operadora</mat-option>
                          <mat-option value="Claro">Claro</mat-option>
                          <mat-option value="TIM">TIM</mat-option>
                          <mat-option value="Vodafone">Vodafone</mat-option>
                          <mat-option value="Vivo">Vivo</mat-option>
                          <mat-option value="Oi">Oi</mat-option>
                          <mat-option value="Nextel">Nextel</mat-option>
                          <mat-option value="Algar">Algar</mat-option>
                          <mat-option value="Porto">Porto</mat-option>
                        </mat-select>

                      </mat-form-field>
                    </div>


                  </mat-dialog-content>
                </form>
              </div>
            </div>

            <div class="panel" *ngIf="localInstalationForm.value.installationSpot">
                <div class="panel-title" [ngClass]="primaryColorBrand">
                  <span>
                    <mat-icon class="white-fg">directions_car</mat-icon>
                  </span>
                  <span class="white-fg">&nbsp;Local da Instalação</span>
                </div>
                <div class="panel-content">
                  <form [formGroup]="localInstalationForm">
                      <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px">
                        <mat-form-field fxFlex="100">
                            <input matInput placeholder="Local da Instalação" formControlName="installationSpot" required style="color: black">
                        </mat-form-field>
                      </div>
                  </form>
                </div>
             </div> 

            <div class="panel" *ngIf="vehicleForm.value.manufacturer || showAddVeicle">
              <div class="panel-title"  [ngClass]="!showAddVeicle ? primaryColorBrand : editColor">
                <mat-icon class="white-fg">directions_car</mat-icon>
                <span class="white-fg">&nbsp;Veículo</span>
              </div>

              <div class="panel-content" *ngIf="vehicleForm.value.manufacturer && !showAddVeicle">
                <form [formGroup]="vehicleForm">
                  <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px">

                    <mat-form-field fxFlex="50">
                      <input matInput placeholder="Marca" formControlName="manufacturer" required style="color: black">
                    </mat-form-field>

                    <mat-form-field fxFlex="50">
                      <input matInput placeholder="Modelo" formControlName="model" required style="color: black">
                    </mat-form-field>
                  </div>

                  <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px">

                    <mat-form-field fxFlex="33">
                      <input matInput placeholder="Ano de fabricação" formControlName="manufacturerYear" required style="color: black">
                    </mat-form-field>

                    <mat-form-field fxFlex="34">
                      <input matInput placeholder="Ano do modelo" formControlName="modelYear" required style="color: black">
                    </mat-form-field>

                    <mat-form-field fxFlex="33">
                      <input matInput placeholder="Cor" formControlName="color" required style="color: black">
                    </mat-form-field>
                  </div>

                  <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px">

                    <mat-form-field fxFlex="50">
                      <input matInput placeholder="Placa" formControlName="licensePlate" required style="color: black">
                    </mat-form-field>

                    <mat-form-field fxFlex="50">
                      <input matInput placeholder="Chassi" formControlName="chassi" required style="color: black">
                    </mat-form-field>
                  </div>

                </form>
              </div>

              <div *ngIf="showAddVeicle">
                <tnm-vehicle-details></tnm-vehicle-details>
              </div>

            </div>



            <div class="panel" *ngIf="generalForm.value.name || showAddCustomer">
              <div class="panel-title" [ngClass]="!showAddCustomer ? primaryColorBrand : editColor">
                <span>
                  <mat-icon class="white-fg">assignment_ind</mat-icon>
                </span>
                <span class="white-fg">&nbsp;Cliente</span>

              </div>

              <div class="panel-content" *ngIf="generalForm.value.name && !showAddCustomer">
                <form [formGroup]="generalForm" novalidate>
                  <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px">
                    <mat-form-field fxFlex="50">
                      <input matInput placeholder="Nome" formControlName="name" style="color: black">
                    </mat-form-field>
                    <mat-form-field fxFlex="50">
                      <input type="email" matInput placeholder="E-mail" formControlName="email" style="color: black">
                    </mat-form-field>
                  </div>

                  <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px">
                    <mat-form-field fxFlex="50">
                      <input matInput placeholder="Cpf" formControlName="registrationNumber" [textMask]="{mask: cpfMask}"
                        style="color: black">
                    </mat-form-field>
                    <mat-form-field fxFlex="50">
                      <input matInput placeholder="Tel. Celular" formControlName="mobilePhone" [textMask]="{mask: mobilePhoneMask}"
                        style="color: black">
                    </mat-form-field>
                  </div>

                </form>
              </div>

              <div *ngIf="showAddCustomer">
                <tnm-customer-personal></tnm-customer-personal>
              </div>
            </div>

            <div class="fuse-widget-front mat-white-bg mat-elevation-z2" *ngIf="showAddVeicle || showAddCustomer || isEdit">

              <div class="px-16 border-bottom" fxLayout="row wrap" fxLayoutAlign="space-between center" [ngClass]="primaryColorBrand"
                fxLayoutAlign="end center">

                <div fxFlex="0 1 auto" class="py-16" fxLayout="row" fxLayoutAlign="end center">
                  <div fxLayout="row" fxLayoutAlign="end center" style="padding-right: 5px;">
                    <div style="padding-right: 5px;">
                      <button mat-raised-button color="warn" style="padding-right: 5px;" (click)="cancelAll()">Cancelar</button>
                    </div>
                    <div style="padding-right: 5px;">
                      <button mat-raised-button *ngIf="device" (click)="saveAll()" class="white-bg">
                        <span>Salvar</span>
                      </button>
                    </div>
                  </div>
                </div>
              </div>
            </div>


          </mat-tab>

          <mat-tab *ngIf="plan && tracknmeOffersList && tracknmeOffersList.length > 0  && isTracknme">
            <ng-template mat-tab-label>
              <span>
                <mat-icon>local_atm</mat-icon>
              </span>
              <span>&nbsp;Plano</span>
            </ng-template>

            <div class="panel" [style.background-color]="statusPlan">

              <div class="panel-content">

                <ng-template matStepLabel>Ofertas</ng-template>
                <div class="price-tables" fxLayout="row wrap" fxLayoutAlign="center center">

    
                    <div class="price-table style-1 mat-elevation-z4" fxLayout="column" *ngFor="let offer of tracknmeOffersList" style="width: 300px" >
                 
                    <div class="package-type mat-accent-bg" [ngClass]="{'mat-accent-bg': checkOffersActive(offer.id), 'mat-primary-bg': !checkOffersActive(offer.id)}" fxLayoutAlign="center center">
                      <span>{{formatOffersName(offer.name)}}</span>
                    </div>

                    <div class="price" fxLayout="row" fxLayoutAlign="center start">
                      <div class="currency">R$</div>
                      <div fxLayout="row" fxLayoutAlign="center end">
                        <div class="value">{{formatOffersPrice(offer.recurrencePrice)}}</div>
                        <div class="period">/ Mensal</div>
                      </div>
                    </div>

                    <div><mat-divider></mat-divider></div>

                    <div class="terms" fxLayout="column">
                      <h3>Descrição</h3>
                      <div class="term">
                          <span class="text-bold">&nbsp;&nbsp;&nbsp;&nbsp;{{formatOffersDescriptionNumber(offer.description)}}</span>
                          {{formatOffersDescription(offer.description)}}
                        </div>
                    </div>
                    
                    <div><mat-divider></mat-divider><br></div>

                    <button *ngIf="checkOffersActive(offer.id)" mat-raised-button [disabled]="true" class="cta-button" color="accent">ATIVO</button> 
                    <button *ngIf="!checkOffersActive(offer.id)" mat-raised-button [disabled]="device && (device.status == 'RETURNED')" class="cta-button" color="accent" (click)="planOffersChange(offer)">SELECIONAR</button>

                  </div> 

                  

                </div>
               

              </div>
            </div>
<!--
            <div class="panel">
              <div class="panel-title" [ngClass]="primaryColorBrand">
                <span>
                  <mat-icon class="white-fg">local_atm</mat-icon>
                </span>
                <span class="white-fg">&nbsp;Cobranças</span>

              </div>

              <div class="panel-content">

                <table class="simple">
                  <thead>
                    <tr>
                      <th>Tipo</th>
                      <th>Tipo de Pagamento</th>
                      <th *ngIf="plan && plan.relationships?.payment && plan.relationships?.payment?.type == 'CREDIT_CARD'">Parcelamento</th>
                      <th>Bandeira</th>
                      <th>Número</th>
                      <th>Valor</th>
                      <th>Status</th>
                      <th>Data</th>
                      <th>Logs da Cobranças</th>
                      <th *ngIf="plan && plan.relationships?.payment && plan.relationships?.payment?.type == 'BOOKLET'"
                        style="text-align: center">Baixar
                        Boleto</th>
                    </tr>
                  </thead>
                  <tbody>
                    <tr *ngFor="let charge of planChargesDataSource">
                      <td>
                        {{ ChargeTypeCardEnumToString(charge.type) }}
                      </td>
                      <td>
                        {{ PaymentTypeEnumToString(plan.relationships?.payment ? charge.payment.type :
                        charge.paymentType) }}
                      </td>
                      <td *ngIf="plan && plan.relationships?.payment && plan.relationships?.payment?.type == 'CREDIT_CARD'">
                        <span *ngIf="charge.installments > 1">Parcelado em&nbsp;{{charge.installments}}x</span>
                        <span *ngIf="charge.installments == 1">Á vista</span>
                      </td>
                      <td>
                        {{ plan.relationships?.payment ? charge.payment.creditCardBrand ?
                        charge.payment.creditCardBrand : charge.payment.debitCardBrand ? charge.payment.debitCardBrand
                        : '-' : '-'}}
                      </td>
                      <td>
                        {{ plan.relationships?.payment ? charge.payment.creditCardNumber ?
                        charge.payment.creditCardNumber : charge.payment.debitCardNumber ?
                        charge.payment.debitCardNumber : '-' : '-'}}
                      </td>
                      <td>
                        {{charge.amount | currency: 'BRL'}}
                      </td>
                      <td>
                        {{ PaymentCreditCardEnumToString(charge.status) }}
                      </td>
                      <td>
                        {{charge.scheduledDateTime | date: 'short'}}
                      </td>

                      <td>
                        <button type="button" mat-icon-button color="accent" (click)="loadChargeLog(charge)" matTooltip="Logs da Cobranças">
                          Logs da Cobranças
                        </button>
                      </td>
                      <td *ngIf="charge.bookletUrl" style="text-align: center">
                        <mat-icon style="cursor:pointer" class="m-0 mr-16" (click)="downloadBooklet(charge.bookletUrl)">cloud_download</mat-icon>
                      </td>

                    </tr>
                  </tbody>
                </table>
              </div>



            </div>-->


          </mat-tab> 

          <mat-tab>

            <ng-template mat-tab-label >
              <span (click)="getImageDevice()">
                <mat-icon>photo_library</mat-icon>
              </span>
              <span (click)="getImageDevice()">&nbsp;Imagens</span>
            </ng-template>


            <div class="panel">
              <div class="panel-title" [ngClass]="primaryColorBrand">
                <span>
                  <mat-icon class="white-fg">photo_library</mat-icon>
                </span>
                <span class="white-fg">&nbsp;Instalação</span>

              </div>

              <!-- <div fxLayout="column" fxLayoutAlign="space-between start" fxLayoutGap="10px">
                <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px">
                  <div fxFlex class="image-document">
                    <mat-card>
                      <img mat-card-image [src]="serviceOrderDocuments?.INSTALLATION_DOCS_TRACKER_TAG ? serviceOrderDocuments?.INSTALLATION_DOCS_TRACKER_TAG : defaultUrl">

                      <mat-card-subtitle>Rastreador</mat-card-subtitle>

                    </mat-card>
                  </div>
                  <div fxFlex class="image-document">
                    <mat-card>
                      <img mat-card-image [src]="serviceOrderDocuments?.INSTALLATION_DOCS_VEHICLE ? serviceOrderDocuments?.INSTALLATION_DOCS_VEHICLE : defaultUrl">
                      <mat-card-subtitle>Veículo</mat-card-subtitle>

                    </mat-card>
                  </div>
                </div>
                <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px">
                  <div fxFlex class="image-document">
                    <mat-card>
                      <img mat-card-image [src]="serviceOrderDocuments?.INSTALLATION_DOCS_TRACKER_SLOT ? serviceOrderDocuments?.INSTALLATION_DOCS_TRACKER_SLOT  : defaultUrl">
                      <mat-card-subtitle>Local de instalação</mat-card-subtitle>

                    </mat-card>
                  </div>
                  <div fxFlex class="image-document">
                    <mat-card>
                      <img mat-card-image [src]="serviceOrderDocuments?.INSTALLATION_DOCS_FORM ? serviceOrderDocuments?.INSTALLATION_DOCS_FORM  : defaultUrl">
                      <mat-card-subtitle>Ficha do Cliente</mat-card-subtitle>

                    </mat-card>
                  </div>
                </div>
                <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px">
                  <div fxFlex class="image-document">
                    <mat-card>
                      <img mat-card-image [src]="serviceOrderDocuments?.INSTALLATION_DOCS_SIGNED_TERM ? serviceOrderDocuments?.INSTALLATION_DOCS_SIGNED_TERM : defaultUrl">
                      <mat-card-subtitle>Assinatura do Cliente</mat-card-subtitle>

                    </mat-card>
                  </div>

                  <div fxFlex class="image-document">
                    <mat-card>
                      <img mat-card-image [src]="serviceOrderDocuments?.INSTALLATION_AFTER_CONCLUSION ? serviceOrderDocuments?.INSTALLATION_AFTER_CONCLUSION : defaultUrl">
                      <mat-card-subtitle>Instalação Finalizada</mat-card-subtitle>

                    </mat-card>
                  </div>
                </div>
              </div> -->



              <div fxLayout="column" fxLayoutAlign="space-between start" fxLayoutGap="10px">
                <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px">
                  <div fxFlex class="image-document">
                    <mat-card>
                      <img mat-card-image [src]="serviceOrderDocuments?.INSTALLATION_DOCS_TRACKER_TAG ? serviceOrderDocuments?.INSTALLATION_DOCS_TRACKER_TAG : defaultUrl">

                      <mat-card-subtitle>Rastreador</mat-card-subtitle>
                      <mat-divider></mat-divider>
                      <br>
                      <div fxLayout="row" fxLayoutAlign="center center" fxLayoutGap="10px">
                        <div class="search-input-wrapper mx-12 m-md-0" fxFlex="1 0 auto" fxLayout="row" fxLayoutAlign="center center">
                          <input [hidden]="true" type="file" (change)="handleFileInput($event.target.files,'INSTALLATION_DOCS_TRACKER_TAG','Instalação')"
                            accept="image/*" #FILE_INSTALLATION_DOCS_TRACKER_TAG>

                          <div fxLayout="row" fxLayoutAlign="center center" fxLayoutGap="10px">
                            <button mat-raised-button color="primary" (click)="FILE_INSTALLATION_DOCS_TRACKER_TAG.click()"
                              [ngClass]="secondColorBrand" mat-button>Selecionar Imagem</button>
                          </div>
                        </div>
                      </div>
                    </mat-card>
                  </div>
                  <div fxFlex class="image-document">
                    <mat-card>
                      <img mat-card-image [src]="serviceOrderDocuments?.INSTALLATION_DOCS_VEHICLE ? serviceOrderDocuments?.INSTALLATION_DOCS_VEHICLE+random_1 : defaultUrl">
                      <mat-card-subtitle>Veículo</mat-card-subtitle>
                      <mat-divider></mat-divider>
                      <br>
                      <div fxLayout="row" fxLayoutAlign="center center" fxLayoutGap="10px">
                        <div class="search-input-wrapper mx-12 m-md-0" fxFlex="1 0 auto" fxLayout="row" fxLayoutAlign="center center">
                          <input [hidden]="true" type="file" (change)="handleFileInput($event.target.files,'INSTALLATION_DOCS_VEHICLE','Instalação')"
                            accept="image/*" #FILE_INSTALLATION_DOCS_VEHICLE>

                          <div fxLayout="row" fxLayoutAlign="center center" fxLayoutGap="10px">
                            <button mat-raised-button color="primary" (click)="FILE_INSTALLATION_DOCS_VEHICLE.click()"
                              [ngClass]="secondColorBrand" mat-button>Selecionar Imagem</button>
                          </div>
                        </div>
                      </div>
                    </mat-card>
                  </div>
                </div>
                <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px">
                  <div fxFlex class="image-document">
                    <mat-card>
                      <img mat-card-image [src]="serviceOrderDocuments?.INSTALLATION_DOCS_TRACKER_SLOT ? serviceOrderDocuments?.INSTALLATION_DOCS_TRACKER_SLOT+random  : defaultUrl">
                      <mat-card-subtitle>Local de instalação</mat-card-subtitle>
                      <mat-divider></mat-divider>
                      <br>
                      <div fxLayout="row" fxLayoutAlign="center center" fxLayoutGap="10px">
                        <div class="search-input-wrapper mx-12 m-md-0" fxFlex="1 0 auto" fxLayout="row" fxLayoutAlign="center center">
                          <input [hidden]="true" type="file" (change)="handleFileInput($event.target.files,'INSTALLATION_DOCS_TRACKER_SLOT','Instalação')"
                            accept="image/*" #FILE_INSTALLATION_DOCS_TRACKER_SLOT>

                          <div fxLayout="row" fxLayoutAlign="center center" fxLayoutGap="10px">
                            <button mat-raised-button color="primary" (click)="FILE_INSTALLATION_DOCS_TRACKER_SLOT.click()"
                              [ngClass]="secondColorBrand" mat-button>Selecionar Imagem</button>
                          </div>
                        </div>
                      </div>
                    </mat-card>
                  </div>
                  <div fxFlex class="image-document">
                    <mat-card>
                      <img mat-card-image [src]="serviceOrderDocuments?.INSTALLATION_DOCS_FORM ? serviceOrderDocuments?.INSTALLATION_DOCS_FORM+random  : defaultUrl">
                      <mat-card-subtitle>Ficha do Cliente</mat-card-subtitle>
                      <mat-divider></mat-divider>
                      <br>
                      <div fxLayout="row" fxLayoutAlign="center center" fxLayoutGap="10px">
                        <div class="search-input-wrapper mx-12 m-md-0" fxFlex="1 0 auto" fxLayout="row" fxLayoutAlign="center center">
                          <input [hidden]="true" type="file" (change)="handleFileInput($event.target.files,'INSTALLATION_DOCS_FORM','Instalação')"
                            accept="image/*" #FILE_INSTALLATION_DOCS_FORM>

                          <div fxLayout="row" fxLayoutAlign="center center" fxLayoutGap="10px">
                            <button mat-raised-button color="primary" (click)="FILE_INSTALLATION_DOCS_FORM.click()"
                              [ngClass]="secondColorBrand" mat-button>Selecionar Imagem</button>
                          </div>
                        </div>
                      </div>
                    </mat-card>
                  </div>
                </div>
                <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px">
                  <div fxFlex class="image-document">
                    <mat-card>
                      <img mat-card-image [src]="serviceOrderDocuments?.INSTALLATION_DOCS_SIGNED_TERM ? serviceOrderDocuments?.INSTALLATION_DOCS_SIGNED_TERM+random : defaultUrl">
                      <mat-card-subtitle>Assinatura do Cliente</mat-card-subtitle>
                      <mat-divider></mat-divider>
                      <br>
                      <div fxLayout="row" fxLayoutAlign="center center" fxLayoutGap="10px">
                        <div class="search-input-wrapper mx-12 m-md-0" fxFlex="1 0 auto" fxLayout="row" fxLayoutAlign="center center">
                          <input [hidden]="true" type="file" (change)="handleFileInput($event.target.files,'INSTALLATION_DOCS_SIGNED_TERM','Instalação')"
                            accept="image/*" #FILE_INSTALLATION_DOCS_SIGNED_TERM>

                          <div fxLayout="row" fxLayoutAlign="center center" fxLayoutGap="10px">
                            <button mat-raised-button color="primary" (click)="FILE_INSTALLATION_DOCS_SIGNED_TERM.click()"
                              [ngClass]="secondColorBrand" mat-button>Selecionar Imagem</button>
                          </div>
                        </div>
                      </div>
                    </mat-card>
                  </div>

                  <div fxFlex class="image-document">
                    <mat-card>
                      <img mat-card-image [src]="serviceOrderDocuments?.INSTALLATION_AFTER_CONCLUSION ? serviceOrderDocuments?.INSTALLATION_AFTER_CONCLUSION+random : defaultUrl">
                      <mat-card-subtitle>Instalação Finalizada</mat-card-subtitle>
                      <mat-divider></mat-divider>
                      <br>
                      <div fxLayout="row" fxLayoutAlign="center center" fxLayoutGap="10px">
                        <div class="search-input-wrapper mx-12 m-md-0" fxFlex="1 0 auto" fxLayout="row" fxLayoutAlign="center center">
                          <input [hidden]="true" type="file" (change)="handleFileInput($event.target.files,'INSTALLATION_AFTER_CONCLUSION','Instalação')"
                            accept="image/*" #FILE_INSTALLATION_AFTER_CONCLUSION>

                          <div fxLayout="row" fxLayoutAlign="center center" fxLayoutGap="10px">
                            <button mat-raised-button color="primary" (click)="FILE_INSTALLATION_AFTER_CONCLUSION.click()"
                              [ngClass]="secondColorBrand" mat-button>Selecionar Imagem</button>
                          </div>
                        </div>
                      </div>
                    </mat-card>
                  </div>
                </div>
              </div>


            </div>
          </mat-tab>

        </mat-tab-group>

      </mat-card-content>
    </mat-card>
  </div>
</div>
